#ifndef _STL_H
#define _STL_H



/**
@brief    STL t@Co͗pCu wb_
@file     STL.h
@author   Fumi.Iseki (C)

@note
GfBAϊ
*/


#include  "exBrep.h"




/// f[^ǂݍݗpꎞf[^
typedef struct {
	unsigned char tmp[50]; 
} tmpSTLData;	// 50Byte



typedef struct {
	float  vect[12];
	unsigned short pad; 
} STLData;		// 52Byte







DllExport STLData* ReadSTLFile (char* fname, long int* fno);
DllExport int      WriteSTLFile(char* fname, SOLID* solid, bool ascii=false);

DllExport STLData* ReadSTLFileA (char* fname, long int* fno);
DllExport STLData* ReadSTLFileB (char* fname, long int* fno);
DllExport int      WriteSTLFileA(char* fname, SOLID* solid);
DllExport int      WriteSTLFileB(char* fname, SOLID* solid);

DllExport void     println_FacetAsciiSTL(CONTOUR* contour);

DllExport void     freeSTL(STLData* stldata);




#endif

