// SetAnimation.cpp : t@C
//

#include "stdafx.h"

#include "Rinions.h"
#include "SetAnimation.h"
#include "WinTools.h"
#include "MessageBoxDLG.h"


// CSetAnimation _CAO

IMPLEMENT_DYNAMIC(CSetAnimation, CDialog)

CSetAnimation::CSetAnimation(CParameterSet prm, BOOL login, CWnd* pParent /*=NULL*/)
	: CDialog(CSetAnimation::IDD, pParent)
{
	param   = prm;
	isLogin	= login;

	animUUIDEBox = NULL;
}




void CSetAnimation::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}



BEGIN_MESSAGE_MAP(CSetAnimation, CDialog)
END_MESSAGE_MAP()




// CSetAnimation bZ[W nh

void CSetAnimation::OnOK()
{
	TCHAR str[SHMIF_INDEX_LEN];
	animUUIDEBox->GetWindowText(str, SHMIF_INDEX_LEN);

//	for (int i=ANM_COM_LEN_UUID; i<SHMIF_INDEX_LEN; i++) str[i] = TCHAR(0);
	if (tcslen(str)!=ANM_COM_LEN_UUID) {
		animUUIDEBox->SetWindowText(param.animationUUID);
		return;
	}
	param.animationUUID = str;

	CDialog::OnOK();
}




BOOL CSetAnimation::OnInitDialog()
{
	CDialog::OnInitDialog();

	animUUIDEBox = (CEdit*)GetDlgItem(IDC_EDIT_ANIMATION_UUID);
	animUUIDEBox->SetWindowText(param.animationUUID);

	if (isLogin) animUUIDEBox->EnableWindow(FALSE);


	return TRUE;  // return TRUE unless you set the focus to a control
}
