// SetViewMode.cpp : t@C
//

#include "stdafx.h"

#include "resource.h"
#include "SetViewMode.h"


// CSetViewMode _CAO

IMPLEMENT_DYNAMIC(CSetViewMode, CDialog)

CSetViewMode::CSetViewMode(CParameterSet prm, NiInputDevice dev, CWnd* pParent /*=NULL*/)
	: CDialog(CSetViewMode::IDD, pParent)
{
	param   = prm;
	device  = dev;

	mrrCBox = NULL;
	imgCBox = NULL;
//	pseCBox = NULL;
}



void CSetViewMode::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}




BEGIN_MESSAGE_MAP(CSetViewMode, CDialog)
END_MESSAGE_MAP()




BOOL CSetViewMode::OnInitDialog()
{
	CDialog::OnInitDialog();

	mrrCBox = (CButton*)GetDlgItem(IDC_CHECK_VIEW_MIRRORING);
	imgCBox = (CButton*)GetDlgItem(IDC_CHECK_VIEW_USEIMAGE);
//	pseCBox = (CButton*)GetDlgItem(IDC_CHECK_FORCE_POSE);

//	if (state!=NI_STATE_DETECT_STOPPED) {
//		pseCBox->EnableWindow(FALSE);
//	}

	if (param.isMirroring) mrrCBox->SetCheck(1);
	else                   mrrCBox->SetCheck(0);
	if (param.isUseImage)  imgCBox->SetCheck(1);
	else                   imgCBox->SetCheck(0);
//	if (param.isForcePose) pseCBox->SetCheck(1);
//	else                   pseCBox->SetCheck(0);

	if (device!=NiDevice_NI) {
		mrrCBox->EnableWindow(FALSE);
	}

	return TRUE;
}




void CSetViewMode::OnOK()
{
	if (mrrCBox->GetCheck()) param.isMirroring = TRUE;
	else                     param.isMirroring = FALSE;
	if (imgCBox->GetCheck()) param.isUseImage  = TRUE;
	else                     param.isUseImage  = FALSE;
//	if (pseCBox->GetCheck()) param.isForcePose = TRUE;
//	else                     param.isForcePose = FALSE;

	CDialog::OnOK();
}
