#pragma once


#include  "NiToolWin.h"


using namespace  jbxwl;


/*
p[^̎gp
CExNiDevice:
	appParam.nextSDKLib			CSetDevice
	appParam.isUseImage			CSetViewMode
	appParam.isMirroring		CSetViewMode
	appParam.isForcePose		CSetViewMode
	appParam.saveDataMode		CSetDataSave
	appParam.savePosMode		CSetDataSave
	appParam.saveRotMode		CSetDataSave
	appParam.saveQutMode		CSetDataSave
	appParam.useDevMotor		CSetDevice
	appParam.useDevLED			CSetDevice

	appParam.usePosData;
	appParam.useRotData;
	appParam.useJointConst;
	appParam.confidence;
	appParam.smoothNITE;
	appParam.smoothMVAV;
	appParam.smoothType;
	appParam.detectParts;

CExNiNetwork:
	appParam.clientPort			CSetNetwork
	appParam.animationUUID		CSetAnimation
	appParam.printNetMode		CSetLogMode
	appParam.printChkMode		CSetLogMode

CExNiSHMemory:
	appParam.animationUUID		CSetAnimation

CExOpenNiWin:
	appParam.printPosMode		CSetLogMode
	appParam.printRotMode		CSetLogMode
	appParam.printQutMode		CSetLogMode
	appParam.netOutMode			CSetNetwork
	appParam.netFastMode		CSetNetwork
*/




enum  NiNetOutMode
{
	NETandLOCAL,
	NETonly 
};



enum  NiFileType
{
	FileDataUnknown,
	FileDataONI,
	FileDataBVH,
	FileDataJTXT,
	FileDataVMD2
};



enum  NiMvAvType 
{
	MVAV_None,
	MVAV_Simple,
	MVAV_Weight,
	MVAV_Expo
};



enum  NiInputDevice 
{
	NiDevice_None,
	NiDevice_NI,
	NiDevice_File
};





////////////////////////////////////////////////////////////////////////////////////
//
// CParameterSet
//

class CParameterSet
{
public:
	CParameterSet()  { init();}
	virtual ~CParameterSet() {}

	void		 init(void);



public:
	// from RINIONS_CONFIG_FILE
	NiSDK_Lib	 nextSDKLib;

	BOOL		 isForcePose;
	BOOL		 isMirroring;
	BOOL		 isUseImage;

	NiNetOutMode netOutMode;
	BOOL		 netFastMode;
	CString		 animationSrvr;
	int			 serverPort;
	int			 clientPort;
	CString		 groupID;
	BOOL		 inAutoBPS;
	int			 inMaxBPS;

	CString		 animationUUID;
	NiFileType   saveDataMode;
	int			 saveBVHFormat;
	int			 saveBVHFPS;
	int			 saveDivTime;
	float		 saveSzScale;

	BOOL		 printPosMode;
	BOOL		 printRotMode;
	BOOL		 printQutMode;
	BOOL		 printNetMode;
	BOOL		 printChkMode;

	BOOL		 useDevLED;
	BOOL		 useDevMotor;

	BOOL		 usePosData;
	BOOL		 useRotData;
	BOOL		 useJointConst;

	//
	BOOL		 useNiteSmooth;
	float		 confidence;
	float		 smoothNITE;

	BOOL		 useKnctSmooth;
	float		 correction;
	float		 smoothKNCT;

	BOOL		 useMvavSmooth;
	NiMvAvType	 mvavType;
	int			 mvavNum;

	float		 YaxisCorrect;
	int			 detectParts;

	//
	BOOL		 outDataCoord;
	BOOL		 outDataQuate;
	BOOL		 outCtrlFPS;
	BOOL		 outAutoFPS;
	int			 outDataFPS;
};



