#pragma once


#include  "NiJointsTool.h"




namespace jbxwl {

using namespace jbxl;


////////////////////////////////////////////////////////////////////////////////////////
//
//  CNiJTextTool Class
//

class CNiJTextTool : public CBaseFrameTool
{
public:
	CNiJTextTool(void);
	virtual ~CNiJTextTool(void);


public:
	void		free_data(void);
	void		clear_data(void);


public:
	virtual NiJointData*	getJointsData(int frmnum, int fps);		// ԃf[^

	virtual BOOL			readFile(FILE* fp);


//
public:
	// ꎞf[^ۑp
	void		writeHeader(FILE* fp) { if (fp!=NULL) fprintf(fp, "%s\n", NI_JTXT_FILE_ID);}
	void		writeCurrentData(FILE* fp, unsigned short msec);
	//
	void		setPosVect(Vector<double>* pos, NiSDK_Lib lib, BOOL mirror);
	void		setRotQuat(Quaternion* rot,     NiSDK_Lib lib, BOOL mirror);

};




}	// name space






