// SetLogMode.cpp : t@C
//

#include "stdafx.h"

//#include "Rinions.h"
#include "resource.h"
#include "SetLogMode.h"


// CSetLogMode _CAO


IMPLEMENT_DYNAMIC(CSetLogMode, CDialog)

CSetLogMode::CSetLogMode(NiSDK_Lib lib, CParameterSet prm, CWnd* pParent /*=NULL*/)
	: CDialog(CSetLogMode::IDD, pParent)
{
	sdk_lib = lib;
	param   = prm;

	posCBox	= NULL;
	rotCBox	= NULL;
	qutCBox	= NULL;
	netCBox	= NULL;
	chkCBox	= NULL;
}



void CSetLogMode::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}




BEGIN_MESSAGE_MAP(CSetLogMode, CDialog)
END_MESSAGE_MAP()




BOOL CSetLogMode::OnInitDialog()
{
	CDialog::OnInitDialog();

	posCBox = (CButton*)GetDlgItem(IDC_CHECK_LOG_POSITION);
	rotCBox = (CButton*)GetDlgItem(IDC_CHECK_LOG_ROT_MATRIX);
	qutCBox = (CButton*)GetDlgItem(IDC_CHECK_LOG_QUATERNION);
	netCBox = (CButton*)GetDlgItem(IDC_CHECK_LOG_NETWORK);
	chkCBox = (CButton*)GetDlgItem(IDC_CHECK_LOG_NET_CHECK);

	if (param.printPosMode) posCBox->SetCheck(1);
	else                    posCBox->SetCheck(0);
	if (param.printRotMode) rotCBox->SetCheck(1);
	else                    rotCBox->SetCheck(0);
	if (param.printQutMode) qutCBox->SetCheck(1);
	else                    qutCBox->SetCheck(0);
	if (param.printNetMode) netCBox->SetCheck(1);
	else					netCBox->SetCheck(0);
	if (param.printChkMode) chkCBox->SetCheck(1);
	else                    chkCBox->SetCheck(0);

	if (sdk_lib==NiSDK_Kinect) {
		rotCBox->SetCheck(0);
		rotCBox->EnableWindow(FALSE);
	}

	return TRUE;
}



void CSetLogMode::OnOK()
{
	if (posCBox->GetCheck()) param.printPosMode = TRUE;
	else                     param.printPosMode = FALSE;
	if (rotCBox->GetCheck()) param.printRotMode = TRUE;
	else                     param.printRotMode = FALSE;
	if (qutCBox->GetCheck()) param.printQutMode = TRUE;
	else                     param.printQutMode = FALSE;
	if (netCBox->GetCheck()) param.printNetMode = TRUE;
	else                     param.printNetMode = FALSE;
	if (chkCBox->GetCheck()) param.printChkMode = TRUE;
	else                     param.printChkMode = FALSE;

	CDialog::OnOK();
}

