#pragma once



#include  "tools++.h"
#include  "MFCTool.h"

#include  "ExNiNetwork.h"



using namespace jbxwl;





class  CExportNiData
{
public:
	CExportNiData(void)  { init();}
	virtual ~CExportNiData(void) {}


public:
	unsigned short	outTimer;
	unsigned short	frameTimer;

	int				modTime;
	int				outPeriod;

	float			frameRate;
	int				frameNum;

	BOOL			ctrlFPS;


public:
	void	init(void); 
	void	clear(void); 
	void	exportJointsData(Vector<double>* posVect, Quaternion* rotQuat, CExNiNetwork* net, NiSDK_Lib lib, int joint_num);


public:
	BOOL	checkOutputPeriod(void);
	void	calcLocalFPS(void);
	void	exportData(Vector<double>* posVect, Quaternion* rotQuat, CExNiNetwork* net, NiSDK_Lib lib, int joint_num);
};