#include  "stdafx.h"

#include  "ParameterSet.h"
#include  "NiBVHTool.h"

#include  "ExNiLib/ExNiNetwork.h"
#include  "ExNiLib/ExNiSHMemory.h"



using namespace jbxwl;




void  CParameterSet::init(void)
{
	//
	nextSDKLib		= NiSDK_OpenNI;

	isForcePose		= FALSE;
	isMirroring		= TRUE;
	isUseImage		= TRUE;

	netOutMode		= NETonly;
	netFastMode		= TRUE;
	animationSrvr	= _T(NINET_DEFAULT_SERVER);
	serverPort      = NINET_UDP_SLPORT;
	clientPort		= NINET_UDP_CLPORT;
	groupID			= _T(NINET_DEFAULT_GROUP);
	inAutoBPS		= FALSE;
	inMaxBPS		= 300;	// kbps

	animationUUID   = _T(SHMIF_DEFAULT_ANIM);
	saveDataMode	= FileDataJTXT;
	saveBVHFormat	= BVH_SAVE_FORMAT_QAV;
	saveBVHFPS		= 30;
	saveDivTime		= 0;
	saveSzScale		= 1.0f;


	printPosMode	= TRUE;
	printRotMode	= FALSE;
	printQutMode	= TRUE;
	printNetMode	= FALSE;
	printChkMode	= FALSE;

	useDevLED		= FALSE;
	useDevMotor		= FALSE;

	usePosData		= TRUE;
	useRotData		= FALSE;
	useJointConst	= TRUE;

	useNiteSmooth	= FALSE;
	confidence		= 0.75f;
	smoothNITE		= 0.0f;

	useKnctSmooth	= FALSE;
	correction		= 0.5f;
	smoothKNCT		= 0.5f;

	useMvavSmooth	= TRUE;
	mvavType		= MVAV_Expo;
	mvavNum			= 3;

	YaxisCorrect	= 0.0f;
	detectParts		= 2;		// XN_SKEL_PROFILE_ALL;

	//
	outDataCoord	= FALSE;
	outDataQuate	= TRUE;
	outCtrlFPS		= FALSE;
	outAutoFPS		= FALSE;
	outDataFPS		= NI_FPS_MAX;
}



