/**
	Rinions.h  by Fumi.Iseki (c)


*/
#pragma once


#ifndef __AFXWIN_H__
	#error "PCH ɑ΂Ẵt@CCN[hO 'stdafx.h' CN[hĂ"
#endif


#include  "resource.h"       // C V{

#include  "ExNiLib/ExNiDevice.h"
#include  "WinBaseLib.h"
#include  "MFCLib.h"

#include  "Rinions_config.h"




extern     CRinionsApp   theApp;




using namespace jbxl;
using namespace jbxwl;




////////////////////////////////////////////////////////////////////////////////////
//
// CRinionsApp:
//

class CRinionsApp : public CWinApp, public CAppCallBack
{
public:
	CRinionsApp();
	virtual ~CRinionsApp();


public:
	CMainFrame*			pMainFrame;
	CLogWndFrame*		pLogFrame;
	CLogWndDoc*			pLogDoc;
		
	CDxDirectView*		pSensorView;
	CDx3DDirectView*	pModelView;

	CNiJoints*			niJoints;
	CExNiDevice*			niDevice;
	CExNiNetwork*			niNetwork;
	CExNiSHMemory*		sharedMem;

	CParameterSet		appParam;


public:
	CMultiDocTemplate*  pDocTemplLOG;
	CMultiDocTemplate*  pDocTemplSNR;
	CMultiDocTemplate*  pDocTemplMDL;


public:
	RECT	windowSize;

	BOOL	isLoggedIn;
	BOOL	isRecvData;
	BOOL	dataSaving;		// f[^ꎞƃt@Cɕۑ
	BOOL	savedData;		// Liۑ\jȈꎞƃt@CL
	BOOL	loadedData;		// ɓǂݍݍς݂̃f[^LiONIt@Cpj

	int		cameraScale;
	int		motorTilt;

public:
	BOOL	InitNiDevice(void);
	void	ShutdownNiDevice(void);
	void	SensorWndOpen(void);
	void	MakeCameraImage(void);


public:
	//
	void	updateStatusBar(BOOL init=FALSE);
	void	updateMenu(CMenu* menu = NULL);
	void	enableSensorWndMenu(CMenu* menu, BOOL enable);
	void	enableLoadedWndMenu(CMenu* menu, BOOL enable);
	void	closeNetwork(BOOL logout);

	char*	configFilePath;
	char*	lockFilePath;

	char*	makeConfigFilePath(void);
	void	readWindowSize (void);
	void	readConfigFile (void);
	void	writeConfigFile(void);

	char*   makeLockFile(BOOL& exec);
	void    deleteLockFile(void);


public:
	virtual BOOL InitInstance();

	virtual void ViewDistructor(CExView* view);
	virtual void ViewDistructor(CExTextView* view);
	virtual void FrameDistructor(CExTextFrame* frm);

	afx_msg void OnAppAbout();

	DECLARE_MESSAGE_MAP()
	afx_msg void OnModelingWndOpen();
	afx_msg void OnLogWndOpen();
	afx_msg void OnSnsrWndOpen_x1();
	afx_msg void OnSnsrWndOpen_x2();
	afx_msg void OnSnsrWndOpen_x3();
	afx_msg void OnSnsrWndOpen_x4();
	afx_msg void OnLddWndOpen_x1();
	afx_msg void OnLddWndOpen_x2();
	afx_msg void OnLddWndOpen_x3();
	afx_msg void OnLddWndOpen_x4();
	afx_msg void OnSettingLogingMode();
	afx_msg void OnSettingViewMode();
	afx_msg void OnSettingOutData();
	afx_msg void OnSettingNetwork();
	afx_msg void OnSettingAnimation();
	afx_msg void OnSettingDataSave();
	afx_msg void OnSettingDevice();
	afx_msg void OnSettingMotion();
	afx_msg void OnAppLogin();
	afx_msg void OnAppLogout();
	afx_msg void OnAppDataLoad();
	afx_msg void OnAppDataSave();
	afx_msg void OnAppDataRecv();
	afx_msg void OnAppReboot();
	afx_msg void OnAppInitialize();
};



